! Read the points to fit.
OPEN "regression_data.txt" FOR INPUT AS #1
points = 0
WHILE NOT EOF(1)
  points = points + 1
  INPUT #1, a, b
WEND
minX = a
maxX = a
minY = b
maxY = b
CLOSE #1

DIM x(points), y(points), pairs(points, 2)
OPEN "regression_data.txt" FOR INPUT AS #1
FOR i = 1 TO points
  INPUT #1, x(i), y(i)
  pairs(i, 1) = x(i)
  pairs(i, 2) = y(i)
  IF minX > x(i) THEN minX = x(i)
  IF maxX < x(i) THEN maxX = x(i)
  IF minY > y(i) THEN minY = y(i)
  IF maxY < y(i) THEN maxY = y(i)
NEXT
CLOSE #1

! Do the regression.
order = 2
coef = Math.polyfit(x, y, order)

! Draw the points and the fit.
DIM p AS Plot
p = Graphics.newPlot

DIM scatter AS PlotPoint
scatter = p.newPlot(pairs)
scatter.setStyle(0)
scatter.setPointStyle(2)

DIM fitPlot AS PlotFunction
fitPlot = p.newFunction(function fit)
fitPlot.setColor(1, 0, 0)

title$ = "f(x) = " & format(coef(1))
FOR i = 1 TO order
  title$ = title$ & " + " & format(coef(i + 1))
  IF i = 1 THEN
    title$ = title$ & "*x"
  ELSE
    title$ = title$ & "*x^" & STR(i)
  END IF
NEXT
title$ = title$ & ", R^2 = " & format(Math.rSquare(x, y, coef))
p.setTitle(title$)

p.setView(minX, minY, maxX, maxY, 1)

System.showGraphics

! This function evaluates the fit. It is used to plot the
! fit for comparison with the points and the actual function.
FUNCTION fit (x)
fit = Math.poly(coef, x)
END FUNCTION

! Format a value with three decimal digits.
FUNCTION format (x AS DOUBLE) AS STRING
sign$ = ""
IF x < 0 THEN
  x = -x
  sign$ = "-"
END IF
x$ = STR(INT(x*1000))
WHILE LEN(x$) < 4
  x$ = "0" & x$
WEND
format = sign$ & LEFT(x$, LEN(x$) - 3) & "." & RIGHT(x$, 3)
END FUNCTION